## pyperscan 0.2.2

=== vectorscan/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.12)

project (vectorscan C CXX)

set (HS_MAJOR_VERSION 5)
set (HS_MINOR_VERSION 4)
set (HS_PATCH_VERSION 8)
set (HS_VERSION ${HS_MAJOR_VERSION}.${HS_MINOR_VERSION}.${HS_PATCH_VERSION})

set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)
include(CheckCCompilerFlag)
include(CheckCXXCompilerFlag)
include(CheckCXXSymbolExists)
INCLUDE (CheckFunctionExists)
INCLUDE (CheckIncludeFiles)
INCLUDE (CheckIncludeFileCXX)
INCLUDE (CheckLibraryExists)
INCLUDE (CheckSymbolExists)
include (CMakeDependentOption)
include (GNUInstallDirs)
include (${CMAKE_MODULE_PATH}/platform.cmake)
include (${CMAKE_MODULE_PATH}/ragel.cmake)

find_package(PkgConfig QUIET)

if (NOT CMAKE_BUILD_TYPE)
    message(STATUS "Default build type 'Release with debug info'")
    set(CMAKE_BUILD_TYPE RELWITHDEBINFO CACHE STRING "" FORCE )
else()
    string(TOUPPER ${CMAKE_BUILD_TYPE} CMAKE_BUILD_TYPE)
    message(STATUS "Build type ${CMAKE_BUILD_TYPE}")
endif()

if(CMAKE_BUILD_TYPE MATCHES NONE|RELEASE|RELWITHDEBINFO|MINSIZEREL)
    message(STATUS "using release build")
    set(RELEASE_BUILD TRUE)
else()
    set(RELEASE_BUILD FALSE)
endif()

set(BINDIR "${PROJECT_BINARY_DIR}/bin")
set(LIBDIR "${PROJECT_BINARY_DIR}/lib")

set(INCLUDE_INSTALL_DIR ${CMAKE_INSTALL_INCLUDEDIR})

# First for the generic no-config case
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${BINDIR}")
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${LIBDIR}")
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${LIBDIR}")
# Second, for multi-config builds (e.g. msvc)
foreach (OUTPUTCONFIG ${CMAKE_CONFIGURATION_TYPES})
    string (TOUPPER ${OUTPUTCONFIG} OUTPUTCONFIG)
    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_${OUTPUTCONFIG} "${BINDIR}")
    set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_${OUTPUTCONFIG} "${LIBDIR}")
    set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY_${OUTPUTCONFIG} "${LIBDIR}")
endforeach (OUTPUTCONFIG CMAKE_CONFIGURATION_TYPES)


if(CMAKE_GENERATOR STREQUAL Xcode)
    set(XCODE TRUE)
endif()

# older versions of cmake don't know things support isystem
if (XCODE OR CMAKE_CXX_COMPILER_ID MATCHES "Intel")
    set(CMAKE_INCLUDE_SYSTEM_FLAG_CXX "-isystem")
endif ()

set(CMAKE_INCLUDE_CURRENT_DIR 1)
include_directories(${PROJECT_SOURCE_DIR}/src)
include_directories(${PROJECT_BINARY_DIR})
include_directories(SYSTEM include)

include (${CMAKE_MODULE_PATH}/boost.cmake)

find_package(Python COMPONENTS Interpreter)
find_program(RAGEL ragel)

if(NOT Python_Interpreter_FOUND)
    message(FATAL_ERROR "No python interpreter found")
endif()

# allow for reproducible builds - python for portability
if (DEFINED ENV{SOURCE_DATE_EPOCH})
      execute_process(
          COMMAND "${PYTHON}" "${CMAKE_MODULE_PATH}/formatdate.py" "$ENV{SOURCE_DATE_EPOCH}"
          OUTPUT_VARIABLE BUILD_DATE
          OUTPUT_STRIP_TRAILING_WHITESPACE)
else ()
    string (TIMESTAMP BUILD_DATE "%Y-%m-%d")
endif ()
message(STATUS "Build date: ${BUILD_DATE}")


if(${RAGEL} STREQUAL "RAGEL-NOTFOUND")
    message(FATAL_ERROR "Ragel state machine compiler not found")
endif()

option(DEBUG_OUTPUT "Enable debug output (warning: very verbose)" FALSE)

if(DEBUG_OUTPUT)
    add_definitions(-DDEBUG)
    set(RELEASE_BUILD FALSE)
endif(DEBUG_OUTPUT)

option(BUILD_SHARED_LIBS "Build shared libs instead of static" OFF)
option(BUILD_STATIC_AND_SHARED "Build shared libs as well as static" OFF)

if (BUILD_STATIC_AND_SHARED OR BUILD_SHARED_LIBS)
        message(STATUS "Building shared libraries")
else()
        message(STATUS "Building static libraries")
endif()

if (NOT BUILD_SHARED_LIBS)
    # build static libs
    set(BUILD_STATIC_LIBS ON)
    mark_as_advanced(BUILD_STATIC_LIBS)
endif ()

#for config
if (RELEASE_BUILD)
    set(HS_OPTIMIZE ON)
endif()

include (${CMAKE_MODULE_PATH}/sanitize.cmake)

CMAKE_DEPENDENT_OPTION(DUMP_SUPPORT "Dump code support; normally on, except in release builds" ON "NOT RELEASE_BUILD" OFF)

CMAKE_DEPENDENT_OPTION(DISABLE_ASSERTS "Disable assert(); Asserts are enabled in debug builds, disabled in release builds" OFF "NOT RELEASE_BUILD" ON)

option(BUILD_AVX512 "Experimental: support avx512 in the fat runtime" OFF)

option(BUILD_AVX512VBMI "Experimental: support avx512vbmi in the fat runtime" OFF)

if (BUILD_AVX512VBMI)
    set(BUILD_AVX512 ON)
endif ()

# TODO: per platform config files?

# remove CMake's idea of optimisation
foreach (CONFIG ${CMAKE_BUILD_TYPE} ${CMAKE_CONFIGURATION_TYPES})
    string(REGEX REPLACE "-O[^ ]*" "" CMAKE_C_FLAGS_${CONFIG} "${CMAKE_C_FLAGS_${CONFIG}}")
    string(REGEX REPLACE "-O[^ ]*" "" CMAKE_CXX_FLAGS_${CONFIG} "${CMAKE_CXX_FLAGS_${CONFIG}}")
endforeach ()

if (CMAKE_C_COMPILER_ID MATCHES "Intel")
    set(SKYLAKE_FLAG "-xCORE-AVX512")
else ()
    set(SKYLAKE_FLAG "-march=skylake-avx512")
    set(ICELAKE_FLAG "-march=icelake-server")
endif ()

if(ARCH_PPC64EL)
    set(ARCH_FLAG mcpu)
else()
    set(ARCH_FLAG march)
endif()

# Detect best GNUCC_ARCH to tune for
if (CMAKE_COMPILER_IS_GNUCC AND NOT CROSS_COMPILE)
    message(STATUS "gcc version ${CMAKE_C_COMPILER_VERSION}")

    # If gcc doesn't recognise the host cpu, then mtune=native becomes
    # generic, which isn't very good in some cases. march=native looks at
    # cpuid info and then chooses the best microarch it can (and replaces
    # the flag), so use that for tune.

    set(TUNE_FLAG "mtune")
    set(GNUCC_TUNE "")
    message(STATUS "ARCH_FLAG '${ARCH_FLAG}' '${GNUCC_ARCH}', TUNE_FLAG '${TUNE_FLAG}' '${GNUCC_TUNE}' ")

    # arg1 might exist if using ccache
    string (STRIP "${CMAKE_C_COMPILER_ARG1}" CC_ARG1)
    set (EXEC_ARGS ${CC_ARG1} -c -Q --help=target -${ARCH_FLAG}=native -${TUNE_FLAG}=native)
    execute_process(COMMAND ${CMAKE_C_COMPILER} ${EXEC_ARGS}
        OUTPUT_VARIABLE _GCC_OUTPUT)
    set(_GCC_OUTPUT_TUNE ${_GCC_OUTPUT})
    string(FIND "${_GCC_OUTPUT}" "${ARCH_FLAG}=" POS)
    string(SUBSTRING "${_GCC_OUTPUT}" ${POS} -1 _GCC_OUTPUT)
    string(REGEX REPLACE "${ARCH_FLAG}=[ \t]*([^ \n]*)[ \n].*" "\\1" GNUCC_ARCH "${_GCC_OUTPUT}")

    string(FIND "${_GCC_OUTPUT_TUNE}" "${TUNE_FLAG}=" POS_TUNE)
    string(SUBSTRING "${_GCC_OUTPUT_TUNE}" ${POS_TUNE} -1 _GCC_OUTPUT_TUNE)
    string(REGEX REPLACE "${TUNE_FLAG}=[ \t]*([^ \n]*)[ \n].*" "\\1" GNUCC_TUNE "${_GCC_OUTPUT_TUNE}")

    string(FIND "${GNUCC_ARCH}" "sve" POS_SVE)
    string(FIND "${GNUCC_ARCH}" "sve2" POS_SVE2)
    string(FIND "${GNUCC_ARCH}" "sve2-bitperm" POS_SVE2_BITPERM)
    if (NOT POS_SVE EQUAL 0)
        set(SVE_FOUND 1)
    elseif(NOT POS_SVE2 EQUAL 0)
        set(SVE2_FOUND 1)
    elseif(NOT POS_SVE2_BITPERM EQUAL 0)
        set(SVE2_BITPERM_FOUND 1)
    endif()

    message(STATUS "ARCH_FLAG '${ARCH_FLAG}' '${GNUCC_ARCH}', TUNE_FLAG '${TUNE_FLAG}' '${GNUCC_TUNE}' ")

    # test the parsed flag
    set (EXEC_ARGS ${CC_ARG1} -E - -${ARCH_FLAG}=${GNUCC_ARCH} -${TUNE_FLAG}=${GNUCC_TUNE})
    execute_process(COMMAND ${CMAKE_C_COMPILER} ${EXEC_ARGS}
        OUTPUT_QUIET ERROR_QUIET
        INPUT_FILE /dev/null
        RESULT_VARIABLE GNUCC_TUNE_TEST)
    if (NOT GNUCC_TUNE_TEST EQUAL 0)
        message(WARNING "Something went wrong determining gcc tune: -mtune=${GNUCC_TUNE} not valid, falling back to -mtune=native")
        set(GNUCC_TUNE native)
    else()
        set(GNUCC_TUNE ${GNUCC_TUNE})
        message(STATUS "gcc will tune for ${GNUCC_ARCH}, ${GNUCC_TUNE}")
    endif()
elseif (CMAKE_COMPILER_IS_CLANG AND NOT CROSS_COMPILE)
    if (ARCH_IA32 OR ARCH_X86_64)
        set(GNUCC_ARCH native)
        set(TUNE_FLAG generic)
    elseif(ARCH_AARCH64)
       set(GNUCC_ARCH armv8)
       set(TUNE_FLAG generic)
    elseif(ARCH_ARM32)
       set(GNUCC_ARCH armv7a)
       set(TUNE_FLAG generic)
    else()
       set(GNUCC_ARCH native)
       set(TUNE_FLAG generic)
    endif()
    message(STATUS "clang will tune for ${GNUCC_ARCH}, ${TUNE_FLAG}")
elseif (CROSS_COMPILE)
    set(GNUCC_ARCH generic)
    set(TUNE_FLAG generic)
endif()

if (ARCH_IA32 OR ARCH_X86_64)
    if (NOT FAT_RUNTIME)
        if (BUILD_AVX512)
            set(ARCH_C_FLAGS "${SKYLAKE_FLAG}")
            set(ARCH_CXX_FLAGS "${SKYLAKE_FLAG}")
        elseif (BUILD_AVX2)
            set(ARCH_C_FLAGS "-mavx2")
            set(ARCH_CXX_FLAGS "-mavx2")
        else()
            set(ARCH_C_FLAGS "-msse4.2")
            set(ARCH_CXX_FLAGS "-msse4.2")
        endif()
    else()
       set(ARCH_C_FLAGS "-msse4.2")
       set(ARCH_CXX_FLAGS "-msse4.2")
    endif()
endif()

if (ARCH_AARCH64)
    if (BUILD_SVE2_BITPERM AND NOT SVE2_BITPERM_FOUND)
        set(GNUCC_ARCH "${GNUCC_ARCH}+sve2-bitperm")
    elseif (BUILD_SVE2 AND NOT SVE2_FOUND)
        set(GNUCC_ARCH "${GNUCC_ARCH}+sve2")
    elseif (BUILD_SVE AND NOT SVE_FOUND)
        set(GNUCC_ARCH "${GNUCC_ARCH}+sve")
    endif ()
endif(ARCH_AARCH64)

message(STATUS "ARCH_C_FLAGS   : ${ARCH_C_FLAGS}")
message(STATUS "ARCH_CXX_FLAGS : ${ARCH_CXX_FLAGS}")

if (NOT FAT_RUNTIME)
    if (GNUCC_TUNE)
        set(ARCH_C_FLAGS "-${ARCH_FLAG}=${GNUCC_ARCH} -${TUNE_FLAG}=${GNUCC_TUNE}")
        set(ARCH_CXX_FLAGS "-${ARCH_FLAG}=${GNUCC_ARCH} -${TUNE_FLAG}=${GNUCC_TUNE}")
    else()
        set(ARCH_C_FLAGS "-${ARCH_FLAG}=${GNUCC_ARCH} -mtune=${TUNE_FLAG} ${ARCH_C_FLAGS}")
        set(ARCH_CXX_FLAGS "-${ARCH_FLAG}=${GNUCC_ARCH} -mtune=${TUNE_FLAG} ${ARCH_CXX_FLAGS}")
    endif()
endif()

#if (ARCH_IA32 OR ARCH_X86_64 OR ARCH_ARM32 OR ARCH_AARCH64)
#    if (NOT CMAKE_C_FLAGS MATCHES .*march.* AND NOT CMAKE_C_FLAGS MATCHES .*mtune.*)
#        set(ARCH_C_FLAGS "-march=${GNUCC_ARCH} -mtune=${TUNE_FLAG}")
#    endif()
#    if (NOT CMAKE_CXX_FLAGS MATCHES .*march.* AND NOT CMAKE_CXX_FLAGS MATCHES .*mtune.*)
#        set(ARCH_CXX_FLAGS "-march=${GNUCC_ARCH} -mtune=${TUNE_FLAG}")
#    endif()
#endif()
    
#if(ARCH_PPC64EL)
#    if (NOT CMAKE_C_FLAGS MATCHES .*march.* AND NOT CMAKE_C_FLAGS MATCHES .*mtune.*)
#        set(ARCH_C_FLAGS "-mtune=${TUNE_FLAG}")
#    endif()
#    if (NOT CMAKE_CXX_FLAGS MATCHES .*march.* AND NOT CMAKE_CXX_FLAGS MATCHES .*mtune.*)
#        set(ARCH_CXX_FLAGS "-mtune=${TUNE_FLAG}")
#    endif()
#endif()

# compiler version checks TODO: test more compilers
if (CMAKE_COMPILER_IS_GNUCXX)
    set(GNUCXX_MINVER "9")
    message(STATUS "g++ version ${CMAKE_CXX_COMPILER_VERSION}")
    if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS GNUCXX_MINVER)
        message(FATAL_ERROR "A minimum of g++ ${GNUCXX_MINVER} is required for C++17 support")
    endif()
endif()

if(RELEASE_BUILD)
    if (NOT CMAKE_BUILD_TYPE MATCHES MINSIZEREL)
        set(OPT_C_FLAG "-O3")
        set(OPT_CXX_FLAG "-O3")
    else ()
        set(OPT_C_FLAG "-Os")
        set(OPT_CXX_FLAG "-Os")
    endif ()
else()
    set(OPT_C_FLAG "-O0")
    set(OPT_CXX_FLAG "-O0")
endif(RELEASE_BUILD)

# set compiler flags - more are tested and added later
set(EXTRA_C_FLAGS "${OPT_C_FLAG} -std=c17 -Wall -Wextra -Wshadow -Wcast-qual -fno-strict-aliasing")
set(EXTRA_CXX_FLAGS "${OPT_CXX_FLAG} -std=c++17 -Wall -Wextra -Wshadow -Wswitch -Wreturn-type -Wcast-qual -Wno-deprecated -Wnon-virtual-dtor -fno-strict-aliasing")
if (NOT CMAKE_COMPILER_IS_CLANG)
    set(EXTRA_CXX_FLAGS "${EXTRA_CXX_FLAGS} -fno-new-ttp-matching")
endif()

if (NOT RELEASE_BUILD)
    # -Werror is most useful during development, don't potentially break
    # release builds
    set(EXTRA_C_FLAGS "${EXTRA_C_FLAGS} -Werror")
    set(EXTRA_CXX_FLAGS "${EXTRA_CXX_FLAGS} -Werror")
    if (CMAKE_COMPILER_IS_CLANG)
	if (CMAKE_C_COMPILER_VERSION VERSION_GREATER "13.0")
           set(EXTRA_C_FLAGS "${EXTRA_C_FLAGS} -Wno-unused-but-set-variable")
           set(EXTRA_CXX_FLAGS "${EXTRA_CXX_FLAGS} -Wno-unused-but-set-variable")
        endif()
    endif()
endif()

if (DISABLE_ASSERTS)
    set(EXTRA_C_FLAGS "${EXTRA_C_FLAGS} -DNDEBUG")
    set(EXTRA_CXX_FLAGS "${EXTRA_CXX_FLAGS} -DNDEBUG")
endif()

if(CMAKE_COMPILER_IS_GNUCC)
    # spurious warnings?
    set(EXTRA_C_FLAGS "${EXTRA_C_FLAGS} -Wno-array-bounds -Wno-maybe-uninitialized")
endif()

if(CMAKE_COMPILER_IS_GNUCXX)
    set(EXTRA_CXX_FLAGS "${EXTRA_CXX_FLAGS} -Wno-maybe-uninitialized")
    if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS 5.0)

=== debian/changelog ===
pyperscan (0.2.2-0parrot1) lory; urgency=medium

  * Rebuild for Parrot 6.0.

 -- Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>  Thu, 07 Sep 2023 02:20:31 +0200

pyperscan (0.2.2-0kali2) kali-experimental; urgency=medium

  * hyperscan doesn't compile on armhf and armel

 -- Sophie Brun <sophie@offensive-security.com>  Fri, 26 May 2023 17:40:43 +0200

pyperscan (0.2.2-0kali1) kali-experimental; urgency=medium

  * Initial release.

 -- Sophie Brun <sophie@offensive-security.com>  Tue, 16 May 2023 17:03:14 +0200

=== debian/control ===
Source: pyperscan
Section: python
Priority: optional
Maintainer: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>
Uploaders: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-python3,
 pybuild-plugin-pyproject,
 cargo,
 cmake,
 libboost-dev,
 librust-bindgen-dev,
 librust-bitflags-dev,
 librust-clap-3-dev,
 librust-cmake-dev,
 librust-env-logger-dev,
 librust-foreign-types-dev,
 librust-humantime-dev,
 librust-libloading-dev,
 librust-libc-dev,
 librust-pyo3-dev,
 librust-thiserror-dev,
 librust-which-dev,
 python3-pytest,
 python3-setuptools,
 python3-all,
 ragel,
 rustfmt,
 rustc (>= 1.64)
Testsuite: autopkgtest-pkg-python
Standards-Version: 4.6.2
Homepage: https://github.com/vlaci/pyperscan

Package: python3-pyperscan
Architecture: amd64 i386 arm64
Depends:
 ${python3:Depends},
 ${misc:Depends},
 ${shlibs:Depends},
Description: pyperscan Python module (Python 3)
 This package contains a Python module pyperscan.
 .
 This package installs the library for Python 3.

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE = 1

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildflags.mk
include /usr/share/rustc/architecture.mk

export PYBUILD_NAME=pyperscan
export CARGO_HOME=$(CURDIR)/debian/cargo_home
export CFLAGS CXXFLAGS CPPFLAGS LDFLAGS
export DEB_HOST_RUST_TYPE DEB_HOST_GNU_TYPE
export DEB_CARGO_CRATE=pyperscan_0.2.2

CARGO=/usr/share/cargo/bin/cargo

%:
	dh $@ --buildsystem=pybuild

execute_after_dh_auto_configure:
	mkdir $(CURDIR)/debian/vendor
	# link-from-system must be the 3rd arg (see
	# /usr/share/cargo/bin/cargo)
	$(CARGO) prepare-debian $(CURDIR)/debian/vendor --link-from-system #--manifest-path extension-module/Cargo.toml
	$(CARGO) build

execute_after_dh_install:
	mv target/*/debug/libpyperscan.so $(CURDIR)/debian/python3-pyperscan/usr/lib/python3/dist-packages/pyperscan/pyperscan.abi3.so
	mv pyperscan.pyi $(CURDIR)/debian/python3-pyperscan/usr/lib/python3/dist-packages/pyperscan/__init__.pyi

override_dh_auto_test:

execute_after_dh_clean:
	rm -rf $(CURDIR)/debian/vendor

## pyperscan 0.3.0

=== debian/changelog ===
pyperscan (0.3.0-0kali1) kali-dev; urgency=medium

  * New upstream version 0.3.0
  * Update debian/copyright
  * Refresh patches
  * Add missing build-deps
  * Use maturin to build and improve build
  * Run the upstream tests during the build

 -- Sophie Brun <sophie@offensive-security.com>  Wed, 13 Mar 2024 10:17:40 +0100

pyperscan (0.2.2-0kali4) kali-dev; urgency=medium

  [ Sophie Brun ]
  * Disable CI build on unsupported arch (armel and armhf)

  [ Steev Klimaszewski ]
  * Bump bindgen dependency in patch to 0.66.1
  * Force gcc/g++-12 on arm64.
  * Prepare for Release

 -- Steev Klimaszewski <steev@kali.org>  Mon, 25 Sep 2023 14:57:30 -0500

pyperscan (0.2.2-0kali3) kali-dev; urgency=medium

  * Refresh patches: adapt pyo3 version for Kali

 -- Sophie Brun <sophie@offensive-security.com>  Fri, 11 Aug 2023 12:09:17 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Source: pyperscan
 Section: python
 Priority: optional
-Maintainer: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>
-Uploaders: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>
+Maintainer: Kali Developers <devel@kali.org>
+Uploaders: Sophie Brun <sophie@offensive-security.com>
 Rules-Requires-Root: no
 Build-Depends:
  debhelper-compat (= 13),
@@ -10,7 +10,10 @@
  pybuild-plugin-pyproject,
  cargo,
  cmake,
+ gcc-12 [arm64],
+ g++-12 [arm64],
  libboost-dev,
+ libhyperscan-dev,
  librust-bindgen-dev,
  librust-bitflags-dev,
  librust-clap-3-dev,
@@ -23,6 +26,7 @@
  librust-pyo3-dev,
  librust-thiserror-dev,
  librust-which-dev,
+ python3-maturin,
  python3-pytest,
  python3-setuptools,
  python3-all,
@@ -32,6 +36,8 @@
 Testsuite: autopkgtest-pkg-python
 Standards-Version: 4.6.2
 Homepage: https://github.com/vlaci/pyperscan
+Vcs-Browser: https://gitlab.com/kalilinux/packages/pyperscan
+Vcs-Git: https://gitlab.com/kalilinux/packages/pyperscan.git
 
 Package: python3-pyperscan
 Architecture: amd64 i386 arm64

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE = 1

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildflags.mk
include /usr/share/rustc/architecture.mk

export PYBUILD_NAME=pyperscan

export CARGO_HOME=$(CURDIR)/debian/cargo_home
export CARGO=/usr/share/cargo/bin/cargo
export DEB_CARGO_CRATE=$(DEB_SOURCE)_$(DEB_VERSION_UPSTREAM)

export CFLAGS CXXFLAGS CPPFLAGS LDFLAGS
export DEB_HOST_RUST_TYPE DEB_HOST_GNU_TYPE

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

# arch detection is broken in gcc-13, so force 12 for now.
ifeq ($(DEB_HOST_ARCH),arm64)
export CC=gcc-12
export CXX=g++-12
endif


%:
	dh $@ --buildsystem=pybuild

execute_before_dh_auto_configure:
	$(CARGO) prepare-debian debian/cargo_registry --link-from-system
	rm -f Cargo.lock

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(@ANY_VERSION@@ARCHIVE_EXT@)%@PACKAGE@-$1%" \
    https://github.com/vlaci/pyperscan/tags \
    (?:.*?/)v?@ANY_VERSION@@ARCHIVE_EXT@ debian debian/script-targz
